----------------------------------------------------
-- Falling Boy est un Projet ralis par Fantasix --
-- Tout droits rservs ! _                     --
----------------------------------------------------
stickman = { 
	x1=125,
	x2=0,
	y1=0,
	y2=0,
	xsize=5,
	ysize=13,
	color=red,
	gravityTimer = Timer.new(),
	mode = 1,
	weight = 0,
	unlocked_mode = "12",
	jump = 0,
	contact = false,
	middlepix=0,
	game_statut = 0,
	screen = SCREEN_DOWN
}
stickman.gravityTimer:start()
gravity_active = true
stylus_press = 1
stylus_linex = 0
stylus_liney = 0
screen_scroll = 0
scrollTimer = Timer.new()
scrollTimer:start()
linePopTimer = Timer.new()
linePopTimer:start()
gameTimer = Timer.new()
gameTimer:start()
teleportation_bonus = true
freeze_bonus = true
freeze_timer = Timer.new()
nb_lines = 0
scroll_speed = 15

lines_tab = {
	{scr = SCREEN_DOWN,	x1=96,	y1=96,	x2=160,	y2=96,	color=Color.new(31,31,31)}
}
math.randomseed(os.time())
-----------------------------------
---          Fonctions          ---
-----------------------------------
function stickman.draw(x,y,color)
	local scr = stickman.screen
	--------------------------
	--  Informations Mode   --
	-- 1 = Normal			--
	-- 2 = SnowMan			--
	--------------------------
	if stickman.mode == 1 then
		if teleportation_bonus then
			screen.print(scr,x,y,"o",Color.new(31,15,15))
		else
			screen.print(scr,x,y,"o",Color.new(31,31,31))
		end
		if freeze_bonus then
			screen.print(scr,x,y+6,"+",Color.new(15,15,31))
		else
			screen.print(scr,x,y+6,"+",Color.new(31,31,31))
		end
		screen.print(scr,x,y+12,"^",color)
		stickman.xsize = 5
		stickman.ysize = 13
		stickman.weight = 5
		stickman.jump = 50
		stickman.color = white
	elseif stickman.mode == 2 then
		screen.print(scr,x,y,"o",color)
		screen.print(scr,x,y+6,"O",color)
		screen.print(scr,x-2,y+3,".",color)
		screen.print(scr,x+3,y+3,".",color)
		screen.print(scr,x,y+13,"^",color)
		stickman.xsize = 7
		stickman.ysize = 14
		stickman.weight = 30
		stickman.jump = 30
		stickman.color = blue
	end
end
function stickman.actualize()
	if stickman.screen == SCREEN_DOWN and stickman.y1 < 2 then
		stickman.screen = SCREEN_UP
		stickman.y1 = 190
	elseif stickman.screen == SCREEN_UP and stickman.y1 > 192 then
		stickman.screen = SCREEN_DOWN
		stickman.y1 = 2
	end
	
	stickman.middlepix = stickman.x1 + math.ceil(stickman.xsize/2)
	stickman.x2 = stickman.x1 + stickman.xsize
	stickman.y2 = stickman.y1 + stickman.ysize
	
	if stickman.x2 >= 256 then stickman.x1 = 255 - stickman.xsize end
	if stickman.x1 < 0 then stickman.x1 = 0 end
	
	if stickman.y2 > 200 and stickman.screen == SCREEN_DOWN then 
		stickman.game_statut = 1
	elseif stickman.y2 < 0 and stickman.screen == SCREEN_UP then 
		stickman.game_statut = 1
	end
	
end
function stickman.platform()
	local contact = false
	local interator = 1
	if nb_lines > 50 then
		interator = nb_lines-50
	end
	for i=interator,#lines_tab do
		if stickman.screen == SCREEN_DOWN then
			if stickman.middlepix >= lines_tab[i].x1 and stickman.middlepix <= lines_tab[i].x2 and stickman.y1+10 < lines_tab[i].y1-screen_scroll and stickman.y2+2 > lines_tab[i].y1-screen_scroll then
				stickman.y1 = lines_tab[i].y1-screen_scroll-stickman.ysize-2
				contact = true
			end
		else
			if stickman.middlepix >= lines_tab[i].x1 and stickman.middlepix <= lines_tab[i].x2 and stickman.y1+10 < lines_tab[i].y1-screen_scroll+192 and stickman.y2+2 > lines_tab[i].y1-screen_scroll+192 then
				stickman.y1 = lines_tab[i].y1-screen_scroll+192-stickman.ysize-2
				contact = true
			end
		end
	end
	return contact
end
function stickman.move()
	local line_i = 0
	if Keys.held.Right and stickman.x2 < 254 then
		stickman.x1 = stickman.x1 + 2
	elseif Keys.held.Left and stickman.x1 > -1 then
		stickman.x1 = stickman.x1 - 2
	end
	
	if Keys.newPress.Up and stickman.contact then
		stickman.y1 = stickman.y1 - stickman.jump
	end
end
function drawBackground()
	local interator = 1
	if nb_lines > 50 then
		interator = nb_lines-50
	end
	for i=interator,#lines_tab do
		if lines_tab[i].scr == SCREEN_DOWN and lines_tab[i].y1-screen_scroll < 0 then
				lines_tab[i].scr = SCREEN_UP
		end
		if lines_tab[i].scr == SCREEN_DOWN then
			screen.drawLine(lines_tab[i].scr,lines_tab[i].x1,lines_tab[i].y1-screen_scroll,lines_tab[i].x2,lines_tab[i].y2-screen_scroll,lines_tab[i].color )
		elseif lines_tab[i].scr == SCREEN_UP and lines_tab[i].y2-screen_scroll+192 > 0 then
				screen.drawLine(lines_tab[i].scr,lines_tab[i].x1,lines_tab[i].y1-screen_scroll+192,lines_tab[i].x2,lines_tab[i].y2-screen_scroll+192,lines_tab[i].color )
		end
	end
end
function addline()
	local rand_y = 192+screen_scroll
	local rand_x = math.random(-100,356)
	local rand_xx = math.random(-100,356)
	local col = Color.new(math.random(15,31),math.random(15,31),math.random(15,31))
	if math.abs(rand_x-rand_xx) < 256 then
		if rand_x < rand_xx then
			table.insert(lines_tab,{scr=SCREEN_DOWN,x1=rand_x,y1=rand_y,x2=rand_xx,y2=rand_y,color=col})
			nb_lines = nb_lines + 1
		elseif rand_x > rand_xx then
			table.insert(lines_tab,{scr=SCREEN_DOWN,x1=rand_xx,y1=rand_y,x2=rand_x,y2=rand_y,color=col})
			nb_lines = nb_lines + 1
		end
	end
	
end
--------------------------
-- Informations Gravit --
--    Entre 1 et 100    --
--  1  = chute lente    --
-- 100 = chute rapide   --
--------------------------
function stickman.gravity(gravity)
	gravity = 100-gravity-stickman.weight
	if not stickman.contact and gravity_active and stickman.gravityTimer:time() > gravity then
		stickman.gravityTimer:reset()
		if not stickman.contact then
			stickman.y1 = stickman.y1 + 1
		end
		stickman.gravityTimer:start()
	end
end
while stickman.game_statut == 0 do
	Controls.read()
	actual_gravity = 100
	
	stickman.actualize()
	stickman.contact = stickman.platform()
	stickman.move()
	stickman.draw(stickman.x1,stickman.y1,stickman.color)
	
	stickman.gravity(actual_gravity)
	drawBackground()
	
	if gameTimer:time() >= 60000 then
		scroll_speed = 5
	elseif gameTimer:time() >= 30000 then
		scroll_speed = 10
	end
	if freeze_timer:time() == 0 then
		if scrollTimer:time() > scroll_speed then
			if stickman.contact then
				stickman.y1 = stickman.y1 - 1
			end
			screen_scroll = screen_scroll + 1
			scrollTimer:reset()
			scrollTimer:start()
		end
		
		if linePopTimer:time() > scroll_speed*40 then
			addline()
			linePopTimer:reset()
			linePopTimer:start()
		end
	end
	-- LES BONUS --
	if Keys.newPress.A and teleportation_bonus then
		teleportation_bonus = false
		if stickman.screen == SCREEN_UP then
			 stickman.screen = SCREEN_DOWN
		else
			stickman.screen = SCREEN_UP
		end
	elseif Keys.newPress.B and freeze_bonus then
		freeze_bonus = false
		freeze_timer:start()
	end
	if freeze_timer:time() > 5000 then
		freeze_timer:reset()
	end
	--------------
	
	screen.print(SCREEN_UP,0,184,NB_FPS)
	screen.print(SCREEN_DOWN,0,0,math.ceil(gameTimer:time()/1000))
	screen.print(SCREEN_DOWN,0,8,"Niv "..math.ceil((15-scroll_speed)/5)+1)
	render()
end
while stickman.game_statut == 1 do
	Controls.read()
	gameTimer:stop()
	
	
	minutes = math.floor(math.ceil(gameTimer:time()/1000)/60)
	secondes = math.ceil(gameTimer:time()/1000)-minutes*60
	
	gameScore = math.ceil(secondes*#lines_tab)
	
	screen.print(SCREEN_DOWN,128-(#"Game Over"*6)/2,88,"Game Over")
	screen.print(SCREEN_DOWN,128-(#("Score : "..gameScore.." pts")*6)/2,96,"Score : "..gameScore.." pts")
	screen.print(SCREEN_DOWN,128-(#("Time : "..minutes.." min "..secondes.." sec")*6)/2,104,"Time : "..minutes.." min "..secondes.." sec")
	
	if Stylus.newPress or Keys.newPress.A or Keys.newPress.Start or Keys.newPress.Select or Keys.newPress.B then 
		break 
	end
	render()
end

dofile("Falling boy.lua")